﻿using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TagCloudGenerator
{
    public partial class Form1 : Form
    {
        //set up for genetic algorithm
        genome[] genomeArray = new genome[10]; //how many should I start with?

        //gather data, rectangles, how many times, total area use to determine if potentially possible

        //initialize data storing arrays    
        string[] wordArray = new string[100];
        string[] wordArrayOrig = new string[100];
        int[] cntArray = new int[100];
        int[] cntArrayOrig = new int[100];

        //to keep record of drawn rectangles
        RectangleF[] recArray = new RectangleF[100];

        int scale = 20;

        int cntsum = 0;
        int cnt = 0;
        int reccnt = 0;
        int gcnt = 0;

        Random rnd = new Random();

        float totalArea;
        Size screenSize;
        float recArea = 0;

        float canvasX, canvasY;

        Graphics formGraphics;

        public Form1()
        {
            InitializeComponent();

            //determine screenSize
            screenSize = Screen.AllScreens.Select(screen => screen.Bounds).Aggregate(Rectangle.Union).Size;
            //totalArea = screenSize.Width * screenSize.Height;
            MessageBox.Show("Screen Width is " + screenSize.Width + ", Screen Height is " + screenSize.Height);

            formGraphics = this.CreateGraphics();

            //read data into arrays
            try
            {
                using (StreamReader sr = new StreamReader("test.txt"))
                {
                    string line;
 
                    while ((line = sr.ReadLine()) != null)
                    {
                        string[] splitted = line.Split(' ');
                        wordArrayOrig[cnt] = splitted[0];
                        //MessageBox.Show(wordArray[cnt]);
                        cntArrayOrig[cnt] = Int32.Parse(splitted[1]);
                        cnt++;
                    }
                   // MessageBox.Show(cnt.ToString());
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Can't open file: " + "\r\n" + e.Message, Application.ProductName);
            }

            //make a copy for wordArray
            for(int i = 0; i < cnt; i++)
            {
                wordArray[i] = wordArrayOrig[i];
                cntArray[i] = cntArrayOrig[i];
            }


            randomizeArrays();

            //for(int i = 0; i < cnt; i++)
            //{
            //    MessageBox.Show("BEFORE: " + wordArrayOrig[i] + " " + cntArrayOrig[i] + "\nAfter: " + wordArray[i] + " " + cntArray[i]);
            //}

            processData();

            
        }

        //changed for my purposes, but based on microsoft example code
        //this function takes a string and its value to generate a rectangle containing the word
        public bool DrawString(string theString, int cntValue)
        {
            Font drawFont = new System.Drawing.Font("Ariel", cntValue); //size should be set according to data
            SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            StringFormat drawFormat = new System.Drawing.StringFormat();

            //randomize only y
            int x,y;

            x = 0;
            y = rnd.Next(screenSize.Height);

            //generate appropriate rectangle
            SizeF param = formGraphics.MeasureString(theString, drawFont);
            Size lw = Size.Round(param);
            Point n = new Point(x, y);

            RectangleF drawRec = new RectangleF(n, param);

            //check if legitimate initial rectangle
            int failures = 0;

            //check for intersection with any other rectangle, inc failures cnt if so
            for (int i = 0; i < reccnt; i++) 
            {
                while (drawRec.IntersectsWith(recArray[i]) || ((drawRec.X + drawRec.Width) >= screenSize.Width) || (drawRec.Y + drawRec.Height > screenSize.Height))
                {
                    //if (drawRec.IntersectsWith(recArray[i]))
                    //    MessageBox.Show("it intersects");

                    if (failures == 100)
                    {
                        //MessageBox.Show("scrapping because too many failures");
                        return false; //exit from function and returns a false
                    }

                    failures++;
                    drawRec.Y = rnd.Next(screenSize.Height);
                    i = 0; //reset i, needs to start from beginning
                }
            }

            //push rectangle to the right until collision, then down until collision

            if (reccnt != 0) //for second one and so on
            {
                //push right until collided
                bool collided = false;
                
                while (!collided)
                {
                    for (int i = 0; i < reccnt; i++) //check for any collisions
                    {
                        if(drawRec.IntersectsWith(recArray[i]) || ((drawRec.X + drawRec.Width) >= screenSize.Width))
                        {
                            collided = true;
                            drawRec.X = drawRec.X - 1;
                        }
                    }
                    drawRec.X = drawRec.X + 1;
                }

                //push down
                collided = false;
                while (!collided)
                {
                    for (int i = 0; i < reccnt; i++) //check for any collisions
                    {
                        if (drawRec.IntersectsWith(recArray[i]) || ((drawRec.Y + drawRec.Height) >= screenSize.Height))
                        {
                            collided = true;
                            drawRec.Y = drawRec.Y - 1;
                        }
                    }
                    drawRec.Y = drawRec.Y + 1;
                }
            }
            else
            {
                //push right until collide
                while ((drawRec.X + drawRec.Width) < screenSize.Width)
                {
                    //MessageBox.Show("here2");
                    drawRec.X = drawRec.X + 1;
                }

                //push down until collide
                while ((drawRec.Y + drawRec.Height) < screenSize.Height)
                {
                    //MessageBox.Show("here2");
                    drawRec.Y = drawRec.Y + 1;
                }
            }


            //add rectangleF to array
            recArray[reccnt] = drawRec; //record into array
            reccnt++;

            recArea = recArea + (drawRec.Width * drawRec.Height);
            //MessageBox.Show("Width: " + drawRec.Width.ToString() + ", Height: " + drawRec.Height.ToString() + ", Area: " + recArea.ToString());

            formGraphics.DrawString(theString, drawFont, drawBrush, drawRec, drawFormat); //draw the string!

            drawFont.Dispose();
            drawBrush.Dispose();

            //MessageBox.Show("HUP");

            return true;
        }
        
        //this function uses a common factor to determine each word's size
        private void processData() //using default scale
        {
            for (int i = 0; i < cnt; i++)
            {
                //reset the cnt and word arrays to the state before the processing(scaling down)
                cntArray[i] = cntArrayOrig[i];
                wordArray[i] = wordArrayOrig[i];

                //make sure font size isn't zero
                if ((cntArray[i] / scale) == 0)
                {
                    cntArray[i] = 1;
                }
                else
                {
                    cntArray[i] = cntArray[i] / scale; //adjust...or implement a converting system to get appropriate sizes
                }

                //MessageBox.Show(cntArray[i].ToString());

                cntsum = cntsum + cntArray[i];
            }
        }

        private void btMinimize_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        //WORK IN PROGRESS
        private void btGenerate_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 10; i++)
            {
                randomizeArrays();
                //reset everything
                formGraphics.Clear(Color.White);

                recArray = new RectangleF[100]; //reset the rectangle array
                reccnt = 0;
                recArea = 0;

                scale = 20;
                processData(); //reprocess data

                generateTags();
                //MessageBox.Show(recArea.ToString() + " out of " + totalArea.ToString());


                //add the genome to generation zero
                genome temp = new genome(recArray, wordArray, cnt, recArea);
                genomeArray[gcnt] = temp;

                //update maxHeight and maxWidth of genome
                genomeArray[gcnt].updateHW();

                //MessageBox.Show((recArea / totalArea).ToString());

                gcnt++;
            }

            //determine the canvas size for the genetic algorithm
            canvasX = genomeArray[0].getminX();
            canvasY = genomeArray[0].getminY();
            for(int i = 1; i < gcnt; i++)
            {
                if (genomeArray[i].getminX() < canvasX)
                    canvasX = genomeArray[i].getminX();
                if (genomeArray[i].getminY() < canvasY)
                    canvasY = genomeArray[i].getminY();
            }

            SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            formGraphics.FillEllipse(drawBrush, canvasX, canvasY, 10, 10);
            MessageBox.Show(canvasX + ", " + canvasY);

            //determine canvas area
            totalArea = (screenSize.Width - canvasX) * (screenSize.Height - canvasY);

            //update genome fitness
            for (int i = 0; i < gcnt; i++)
            {
                genomeArray[i].updateFitness(totalArea);
            }

            for (int i = 0; i < gcnt; i++)
            {
                //MessageBox.Show(i.ToString() + ": " + genomeArray[i].getWord(0) + " " + genomeArray[i].getRec(0).Width.ToString());
                //MessageBox.Show(genomeArray[i].getFitness().ToString());
                MessageBox.Show(genomeArray[i].getFitness().ToString());
            }
        }

        //this function goes through the data arrays and generates tags
        private bool generateTags()
        {
            //while (DrawString("test", 50))
            //{
            //    MessageBox.Show("HUP");
            //}

            for (int i = 0; i < cnt; i++)
            {
                if (!DrawString(wordArray[i], cntArray[i])) //if ever unable to generate with certain scale
                {
                    //MessageBox.Show("CLEAR");
                    formGraphics.Clear(Color.White);

                    recArray = new RectangleF[100]; //reset the rectangle array
                    reccnt = 0;
                    recArea = 0;

                    scale = scale + 5;
                    //MessageBox.Show("scale inc to " + scale.ToString());
                    cntsum = 0;

                    processData(); //reprocess data
                    //MessageBox.Show("scale set to " + scale.ToString());

                    //redraw everything with adjusted scale
                    if (generateTags())
                    {
                        break; //if successful, break
                    }
                }
            }
            return true;
        }

        //randomize the arrays for gen zero
        private void randomizeArrays()
        {
            //randomize
            Random r = new Random();
            string tempstr;
            int tempint;

            for (int i = 0; i < cnt; i++)
            {
                //swap content randomly
                int num = r.Next(0, cnt);
                //MessageBox.Show(num.ToString());
                tempstr = wordArrayOrig[i];
                tempint = cntArrayOrig[i];

                //MessageBox.Show(tempstr);

                wordArrayOrig[i] = wordArrayOrig[num];
                cntArrayOrig[i] = cntArrayOrig[num];

                wordArrayOrig[num] = tempstr;
                cntArrayOrig[num] = tempint;
            }

            //MessageBox.Show(wordArray[1]);
            return;
        }

        //for testing purposese
        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            //MessageBox.Show(e.X.ToString() + ", " + e.Y.ToString());
        }
    }
}

//genome class
class genome
{
    private RectangleF[] recArray;
    private string[] wordArray;
    private float minX, minY; //to get "standardized" canvas
    private float fitness; //the less space left, the stronger its strength, measured using largest screen size
    private int wordcnt;
    private float areaUsed;

    //constructor
    public genome(RectangleF[] recs, string[] words, int cnt, float recArea)
    {
        recArray = new RectangleF[cnt];
        wordArray = new string[cnt];

        for (int i = 0; i < cnt; i++)
        {
            recArray[i] = recs[i];
            wordArray[i] = words[i];
        }

        //need to adjust fitness to get appropriate strength
        fitness = 0; //default set to 0
        minX = 0;
        minY = 0;
        wordcnt = cnt;
        areaUsed = recArea;
    }

    public float getFitness()
    {
        return fitness;
    }

    public RectangleF getRec(int index)
    {
        return recArray[index];
    }

    public string getWord(int index)
    {
        return wordArray[index];
    }

    public float getminX()
    {
        return minX;
    }

    public float getminY()
    {
        return minY;
    }

    public void updateHW() //update the height and width
    {
        minX = recArray[0].X;
        minY = recArray[0].Y;
        for(int i = 1; i < wordcnt; i++)
        {
            if (recArray[i].X < minX)
                minX = recArray[i].X;
            if (recArray[i].Y < minY)
                minY = recArray[i].Y;
        }
        return;
    }

    public void updateFitness(float totArea)
    {
        fitness = (areaUsed / totArea);
    }
} //genome class end

//to do:
//measure strength and make genomes, determine standardized "canvas" size to determine fitness 

//if canvas is equal to entire screen, then scale should increase

//work on how to do crossover and mutation